# Vet environment variables.
profit_status=0
if test "x$APEC" = x; then
  profit_status=1
  echo "profit_init.sh: ERROR: APEC environment variable is not set." >&2
elif test ! -d $APEC; then
  profit_status=1
  echo "profit_init.sh: ERROR: invalid APEC environment variable: $APEC is not a directory." >&2
elif test ! -f $APEC/lib/libfitsspec.a; then
  profit_status=1
  echo "profit_init.sh: ERROR: invalid APEC environment variable: $APEC/lib is missing some libraries." >&2
elif test -x $APEC; then
  APEC=`cd $APEC; pwd`
fi

if test "x$PROFIT" = x; then
  profit_status=1
  echo "profit_init.sh: ERROR: PROFIT environment variable is not set." >&2
elif test ! -d $PROFIT; then
  profit_status=1
  echo "profit_init.sh: ERROR: invalid PROFIT environment variable: $PROFIT is not a directory." >&2
elif test ! -f $PROFIT/bin/profit_binary; then
  profit_status=1
  echo "profit_init.sh: ERROR: invalid PROFIT environment variable: $PROFIT/bin/profit_binary is not a file." >&2
elif test ! -x $PROFIT/bin/profit_binary; then
  profit_status=1
  echo "profit_init.sh: ERROR: invalid PROFIT environment variable: $PROFIT/bin/profit_binary file is not executable." >&2
elif test -x $PROFIT; then
  PROFIT=`cd $PROFIT; pwd`
fi

if test "x$ROOTSYS" = x; then
  profit_status=1
  echo "profit_init.sh: ERROR: ROOTSYS environment variable is not set." >&2
elif test ! -d $ROOTSYS; then
  profit_status=1
  echo "profit_init.sh: ERROR: invalid ROOTSYS environment variable: $ROOTSYS is not a directory." >&2
elif test ! -f $ROOTSYS/bin/root; then
  profit_status=1
  echo "profit_init.sh: ERROR: invalid ROOTSYS environment variable: $ROOTSYS/bin/root is not a file." >&2
elif test ! -x $ROOTSYS/bin/root; then
  profit_status=1
  echo "profit_init.sh: ERROR: invalid ROOTSYS environment variable: $ROOTSYS/bin/root file is not executable." >&2
elif test -x $ROOTSYS; then
  ROOTSYS=`cd $ROOTSYS; pwd`
fi

# If everything is cool so far, perform environment initialization.
if test $profit_status -eq 0; then
  # Set PFILES
  PFILES="$HOME/pfiles;$APEC/pfiles"
  export PFILES

  # Add valgrind.
  valgrind="/data/raid1/peachey/valgrind/2.0.0"
  PATH=`echo ":$PATH:" | sed -e "s#:$valgrind/bin:#:#g" | sed -e "s#^#$valgrind/bin#" | sed -e 's#::*#:#g' | sed -e 's#:$##'`
  LD_LIBRARY_PATH=`echo ":$LD_LIBRARY_PATHPATH:" | sed -e "s#:$valgrind/lib:#:#g" | sed -e "s#^#$valgrind/lib#" | sed -e 's#::*#:#g' | sed -e 's#:$##'`
  
  # Changes to PATH
  PATH=`echo ":$PATH:" | sed -e "s#:$APEC/bin:#:#g" | sed -e "s#^#$APEC/bin#" | sed -e 's#::*#:#g' | sed -e 's#:$##'`
  PATH=`echo ":$PATH:" | sed -e "s#:$ROOTSYS/bin:#:#g" | sed -e "s#^#$ROOTSYS/bin#" | sed -e 's#::*#:#g' | sed -e 's#:$##'`
  PATH=`echo ":$PATH:" | sed -e "s#:$PROFIT/bin:#:#g" | sed -e "s#^#$PROFIT/bin#" | sed -e 's#::*#:#g' | sed -e 's#:$##'`
  export PATH
  DYLD_LIBRARY_PATH=`echo ":$DYLD_LIBRARY_PATH:" | sed -e "s#:$APEC/lib:#:#g" | sed -e "s#^#$APEC/lib#" | sed -e 's#::*#:#g' | sed -e 's#:$##'`
  DYLD_LIBRARY_PATH=`echo ":$DYLD_LIBRARY_PATH:" | sed -e "s#:$ROOTSYS/lib:#:#g" | sed -e "s#^#$ROOTSYS/lib#" | sed -e 's#::*#:#g' | sed -e 's#:$##'`
  DYLD_LIBRARY_PATH=`echo ":$DYLD_LIBRARY_PATH:" | sed -e "s#:$PROFIT/lib:#:#g" | sed -e "s#^#$PROFIT/lib#" | sed -e 's#::*#:#g' | sed -e 's#:$##'`
  export DYLD_LIBRARY_PATH
  LD_LIBRARY_PATH=`echo ":$LD_LIBRARY_PATH:" | sed -e "s#:$APEC/lib:#:#g" | sed -e "s#^#$APEC/lib#" | sed -e 's#::*#:#g' | sed -e 's#:$##'`
  LD_LIBRARY_PATH=`echo ":$LD_LIBRARY_PATH:" | sed -e "s#:$ROOTSYS/lib:#:#g" | sed -e "s#^#$ROOTSYS/lib#" | sed -e 's#::*#:#g' | sed -e 's#:$##'`
  LD_LIBRARY_PATH=`echo ":$LD_LIBRARY_PATH:" | sed -e "s#:$PROFIT/lib:#:#g" | sed -e "s#^#$PROFIT/lib#" | sed -e 's#::*#:#g' | sed -e 's#:$##'`
  export LD_LIBRARY_PATH
fi

# Clean up.
unset profit_status
