/*
  Modified by Ronnie Hoogerwerf OCT-9-2002
 */
#include <pfile.h>

void alloc_spectrum(int Z, int ionJ, struct BIN_SPEC *spectrum);
void allocate_level_rates(int nlev, struct LEVEL_RATES *level_rates);
void apec_nei(struct PARAMETERS *params, struct BIN_SPEC spectrum,
	      ElementP *Atomic_params, struct ION_BAL_TABLE *ionbal, 
	      struct DEBUG_FILES debug);
void assume_recomb_rates(double pop0, double pop1,double qion,
			 double *qrecomb, double *ionc); 
void bin_lines(int Z, int ionJ, double min_epsilon,
	       struct EMISSION_LINES *line, struct BIN_SPEC *spectrum);
void bremsstrahlung(int Z, int ionJ, double abund, double Ion_pop,
		    char *filemap_file, int Brems_Type, 
		    double T, struct BIN_SPEC *spectrum);
void calc_emission(struct DEBUG_FILES *debug,
		   double abund[], double Ion_pop, double *Lev_pop, 
		   struct ELEMENT_ION_STATE *state,
		   double Te, double Ne, 
		   struct TWOPHOT_DATA *twophot,
		   struct EMISSION_LINES **line);
void calc_emission_features(struct DEBUG_FILES *debug,
			    struct ELEMENT_ION_STATE *state,
			    double abund, double Te, double Ion_pop, 
			    struct EMISSION_LINES **line, 
			    struct BIN_SPEC *spectrum);
void calc_ionbal(double Te, double Ne, struct ELEMENT_ION_STATE *state,
		 struct DEBUG_FILES *debug,
		 struct LEVEL_RATES *level_rates, double Ion_pop[],
		 struct EMISSION_LINES **ionrec_line);
void calc_ionrec_rate(double Te, double Ne, double dt, 
		      struct DEBUG_FILES *debug,
		      struct ELEMENT_ION_STATE *state, 
		      double init_lev_pop[], 
		      double ioniz_rate[], double recomb_rate[],
		      struct EMISSION_LINES *ionrec_line);
/* void calc_ioniz_rate(double Te, double Ne, struct DEBUG_FILES *debug,
		     struct PARAMETERS *params,
		     struct ELEMENT_ION_STATE *state, double *ioniz_rate); */
void calc_rad_rec_cont(struct DEBUG_FILES *debug, 
		       int Z, int iIonState, double abund, double this_ion_pop,
		       struct ELEMENT_ION_STATE *pstate,
		       struct ELEMENT_ION_STATE *state,		       
		       double Te, double min_emission, 
		       double *LevRecombRate, struct BIN_SPEC *spectrum);
/* 
void calc_recomb_rate(double Te, double Ne, struct DEBUG_FILES *debug,
		      struct PARAMETERS *params,
		      struct ELEMENT_ION_STATE *state, double *recomb_rate);
*/
void calc_satellite(struct DEBUG_FILES *debug,
		    double abund, double Ion_pop, 
		    struct ELEMENT_ION_STATE *pstate,
		    struct ELEMENT_ION_STATE *dstate, 
		    double Te, double Ne, double level_pop[], 
		    struct EMISSION_LINES **line);
void calc_spectrum_per_ion(int Z, double Ion_pop[], 
			   struct EMISSION_LINES *line, 
			   struct BIN_SPEC *spectrum);
void calc_trans_rates(struct DEBUG_FILES *debug, 
		      struct ELEMENT_ION_STATE *state,
		      double Te, double Tp, double Ne, 
		      struct TRANS_RATES *trans_rates);
void calc_two_phot(struct DEBUG_FILES *debug,
		   struct ELEMENT_ION_STATE *state,
		   struct TWOPHOT_DATA *twophot, struct BIN_SPEC *spectrum);
void clear_lines(struct EMISSION_LINES **line);
void clear_spectrum(int N_Z, int list_Z[], struct BIN_SPEC *spectrum);
void close_debug_output(struct DEBUG_FILES *debug);
void dealloc_level_rates(int Z, struct LEVEL_RATES *level_rates);
void fits_output(struct PARAMETERS *params, double Te, double Ne, int iTemp,
		 int iDens, struct EMISSION_LINES **line, 
		 struct BIN_SPEC *spectrum);
void find_ion_bal(int Z, double Te, double Ne, double Ion_pop[], 
		  struct ION_BAL_TABLE *ionbal, struct PARAMETERS *params);
void fits_close(struct PARAMETERS *params);
void get_input_data(int argc, char *argv[], Param_File_Type *p_input,
		    struct PARAMETERS *params,
		    struct DEBUG_FILES *debug);
void initialize(struct PARAMETERS *params, struct BIN_SPEC *spectrum,
		ElementP **Atomic_params, double **abund, 
		struct ION_BAL_TABLE *ionbal, 
		struct TRANS_RATES *trans_rates, 
		double **Lev_pop, 
		struct DEBUG_FILES *debug, 
		int *maxZ, int *maxNlev);
void print_table(struct DEBUG_FILES *debug,
		 struct ELEMENT_ION_STATE *state);  
void solve_rate_eqns(struct DEBUG_FILES *debug, 
		     struct TRANS_RATES *trans_rates, 
		     struct LEVEL_RATES *level_rates,
		     double Ne, double *Lev_pop);
void write_debug(struct DEBUG_GENERIC *debug, int ascii, int fits, 
		 char* fmt, ...);

