struct atomstr {
  int Z;
  int rmJ;
  char File[MAXSTRLEN];
  struct atomstr *next;
};

typedef struct {
  char *modelname;
  char *outputtype;
  char *filemap_file;
  char *ionbal_file;
  char *abund_source;
  double min_epsilon;
  SLang_Array_Type *T_array;
  SLang_Array_Type *N_array;
  int Nbin;
  double BinMin;
  double BinMax;
  char *inc_atoms;
  char *inc_ions;
  int do_rrc;
  int do_sat;
  int do_lines;
  int do_twoph;
  int do_brems;
  char *brems_type;
} APEC_Param_Type;


SLang_CStruct_Field_Type APEC_Param_Layout [] =
  {
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, modelname, "ModelName", 
		       SLANG_STRING_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, outputtype, "OutputType", 
		       SLANG_STRING_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, filemap_file, "filemap", 
		       SLANG_STRING_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, ionbal_file, "ionbal_file", 
		       SLANG_STRING_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, abund_source, "abundance",
		       SLANG_STRING_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, min_epsilon, "min_epsilon",
		       SLANG_DOUBLE_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, T_array, "T_array",
		       SLANG_ARRAY_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, N_array, "N_array",
		       SLANG_ARRAY_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, Nbin, "Nbin", SLANG_INT_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, BinMin, "BinMin",
		       SLANG_DOUBLE_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, BinMax, "BinMax",
		       SLANG_DOUBLE_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, inc_atoms, "Atoms",
		       SLANG_STRING_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, inc_ions, "Ions",
		       SLANG_STRING_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, do_rrc, "calc_RRC",
		       SLANG_INT_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, do_sat, "calc_DR",
		       SLANG_INT_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, do_lines, "calc_Lines",
		       SLANG_INT_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, do_twoph, "calc_TwoPh",
		       SLANG_INT_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, do_brems, "calc_Brems",
		       SLANG_INT_TYPE, 0),
    MAKE_CSTRUCT_FIELD(APEC_Param_Type, brems_type, "BremsType",
		       SLANG_STRING_TYPE, 0),
    SLANG_END_CSTRUCT_TABLE
  };
