/** \file ProfitApplication.h
    \brief Declaration of ProfitApplication class.
    \author James Peachey

    The Profit software package was developed by Dr. Randall Smith and
    Mr. James Peachey at the High Energy Astrophysics Science Archive
    Research Center (HEASARC) at the Goddard Space Flight Center (GSFC)
    of the National Aeronautics and Space Administration (NASA).
*/
#ifndef profit_ProfitApplication_h
#define profit_ProfitApplication_h

#include "profit/Application.h"

namespace profit {

  class Gui;

  /** \class ProfitApplication
      \brief Class encapsulating the main profit application.
  */
  class ProfitApplication : public Application {
    public:
      /// \brief Construct the main profit application.
      ProfitApplication();

      /// \brief Destroy this application.
      virtual ~ProfitApplication();

    protected:
      /// \brief Perform the detailed action apppropriate for this application.
      virtual void runApp();

    private:
      Gui * m_gui;
  };
}

#endif
